package nc.ui.pubapp.uif2app.actions;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.itf.bd.defdoc.IDefdocService;
import nc.itf.th.IThOcrService;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.uif2.editor.BillForm;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.pubapp.pattern.pub.SqlBuilder;
public class MultiSelectDialog extends UIDialog {

	/**
	 * ӷƱƻȡƱ
	 */
	
	private static final long serialVersionUID = 1L;
	private BillForm editor;
	private JTable table;
	/** ȷť */
	private UIButton btnOK;
	private ActionHandler actionHandler = new ActionHandler();
	private UIPanel btnUIPanel;
	private IUAPQueryBS iuap= (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private IVOPersistence IVOPersistence = (IVOPersistence) NCLocator.getInstance().lookup(IVOPersistence.class);
	private List<DefdocVO> listDefdocVO = new ArrayList<DefdocVO>();
	private IDefdocService idefservice = NCLocator.getInstance().lookup(IDefdocService.class);
	private String billmaker = InvocationInfoProxy.getInstance().getUserId();
	private String pk_group = InvocationInfoProxy.getInstance().getGroupId();
	private String vdef17 = null;
	public MultiSelectDialog(BillForm editor) throws Exception {
		this.editor = editor;
		BillCardPanel cpanel=editor.getBillCardPanel();
		vdef17 = (String) cpanel.getHeadItem("vdef17").getValueObject();
		initialize();
		addComponents();
	}

	/**
	 * ʼ
	 */
	private void initialize() {
		setLayout(new BorderLayout());
		this.setBounds(500, 400, 1500, 700);
		this.setResizable(true);
		add(this.getBtnUIPanel(), BorderLayout.SOUTH);
		// Ӽ
		this.addActionListener();
	}
	
	/**
	 * ļ
	 */
	private void addActionListener() {
		this.getBtnOK().addActionListener(this.actionHandler);

	}
	
	
	public UIPanel getBtnUIPanel() {
		if (btnUIPanel == null) {
			btnUIPanel = new nc.ui.pub.beans.UIPanel();
			btnUIPanel.add(this.getBtnOK(), this.getBtnOK().getName());
		}
		return this.btnUIPanel;
	}
	
	private UIButton getBtnOK() {
		if (btnOK == null) {
			btnOK = new UIButton();
			btnOK.setName("btnOK");
			btnOK.setText("ȷ(Y)");
		}
		return this.btnOK;
	}
	@Override
	public String getTitle() {
		// TODO Զɵķ
		return "ӷƱƻȡƱ";
	}
	
	private void addComponents() throws Exception {
	    JPanel panel = new JPanel(new BorderLayout());
	    IThOcrService  ocrservice=(IThOcrService) NCLocator.getInstance().lookup(IThOcrService.class.getName());
	  //ȡtoken
	  	String token="";
	  	JSONObject json = null;
	  	try {
			token=ocrservice.getToken(billmaker);
		} catch (Exception e) {
			throw new Exception("ȡƱtokenʧ:"+e.getMessage());
		}
	  	
	  	try {
			json = ocrservice.SelectORCInvoice(token);
	  } catch (Exception e) {
			throw new Exception("ȡƱƷƱ:"+e.getMessage());
		}
	    try {
	    	JSONObject data = json.getJSONObject("data");
			JSONArray infos = data.getJSONArray("infos");
			//ƱвڷƱ
			if(infos != null) {
				List<Object[]> dataList = new ArrayList<Object[]>();
				for(int j = 0;j < infos.size();j++){
					JSONObject info = infos.getJSONObject(j);
					String memo = info.getString("number");//Ʊ
					String code = info.getString("number");//Ʊ
					String fid = info.getString("fid");
					
					//ⷢƱƱźͷƱ벻
					if(code == null || "".equals(code)) {
						memo = "ⷢƱ"+fid;
						code = fid;
					}
					String ext = info.getString("ext");
					JSONObject extobj = JSONObject.parseObject(ext);
					String trate = extobj.getString("trate");//˰
					
					JSONObject modify_info = info.getJSONObject("modify_info");
					String name = modify_info.getString("fname");
					JSONObject comm_info = info.getJSONObject("comm_info");
					JSONObject pro = comm_info.getJSONObject("pro");
					String date = pro.getString("date");//Ʊ
					String type = pro.getString("type");//Ʊ
					String cname = pro.getString("cname");//Ʊ
					String kind = pro.getString("kind");//Ʊ
					JSONObject price = comm_info.getJSONObject("price");
					String amount = "";
					String total = "";
					String dtax = "";
					//רƱ˰רƱ˰=˰ϼ
					if(type.equals("1")||type.equals("28")||type.equals("32")){
						amount = price.getString("amount");//˰
						total = price.getString("total");//˰ϼ
						dtax = price.getString("dtax");//ɵֿ˰
					}
					else{
						amount = price.getString("total");//˰
						total = amount;//˰ϼ
						dtax = "0";//ɵֿ˰
						trate = "0";//רƱ˰ҲΪ0
					}
					JSONObject buyer = comm_info.getJSONObject("buyer");
					String mnecode = buyer.getString("tcode");//˰ʶ
					String name2 = buyer.getString("company");//򷽹˾
					JSONObject payer = comm_info.getJSONObject("payer");
					String name3 = payer.getString("tcode");//۷˰ʶ
					String name4 = payer.getString("company");//򷽹˾
					DefdocVO defvo = new DefdocVO();
					defvo.setAttributeValue("code", code);
					defvo.setAttributeValue("name", memo);
					defvo.setAttributeValue("memo", name );
					defvo.setAttributeValue("mnecode", mnecode);
					defvo.setAttributeValue("name2", name2);
					defvo.setAttributeValue("name3", name3);
					defvo.setAttributeValue("name4", name4);
					defvo.setAttributeValue("name5", fid);
					defvo.setAttributeValue("name6", vdef17);
					defvo.setAttributeValue("pk_defdoclist", QryOCRPk());
					defvo.setAttributeValue("pk_group", pk_group);
					defvo.setAttributeValue("pk_org", pk_group);
					defvo.setAttributeValue("datatype", 1);
					defvo.setAttributeValue("enablestate", 2);
					defvo.setAttributeValue("shortname", amount);
					defvo.setAttributeValue("shortname2", total);
					defvo.setAttributeValue("shortname3", dtax);
					defvo.setAttributeValue("shortname4", date);
					defvo.setAttributeValue("shortname5", cname);
					defvo.setAttributeValue("shortname6", trate);
					defvo.setAttributeValue("enablestate", 2);
					defvo.setAttributeValue("innercode", "1");//0ϴ 1Ʊƻȡ
					defvo.setAttributeValue("pid", kind);
					listDefdocVO.add(defvo);
					Boolean blen = QryOCRNumber(code, "1")  == null ? false : true;
					
					Object[] obj = {blen,cname,amount,dtax,trate,total,code,memo,name,mnecode,name2,name3,name4,kind,date};
					dataList.add(obj);
				}
				String[] columnNames = {"ѡ","Ʊ", "Ʊ","˰","˰","˰ϼ","Ʊ","Ʊ","Ʊ","˰ʶ","򷽹˾","۷˰ʶ","۷˾","Ʊ","Ʊʱ"};
				Object[][] dataArray = new Object[dataList.size()][columnNames.length];
				for (int i = 0; i < dataList.size(); i++) {
		            Object[] rowData = dataList.get(i);
		            dataArray[i] = rowData;
		        }
				DefaultTableModel model = new DefaultTableModel(dataArray, columnNames) {
			        @Override
			        public boolean isCellEditable(int row, int column) {
			            return (column == 0); // ֻһпɱ༭
			        }
			    };

			    table = new JTable(model);
			    table.getColumnModel().getColumn(0).setPreferredWidth(50);
			    table.getColumnModel().getColumn(0).setMaxWidth(50);
			    table.getColumnModel().getColumn(0).setCellRenderer(new CheckBoxRenderer());
			    table.getColumnModel().getColumn(0).setCellEditor(new CheckBoxEditor());
			    table.getColumnModel().getColumn(1).setPreferredWidth(150);
			    table.getColumnModel().getColumn(2).setPreferredWidth(150);
			    table.setRowSelectionAllowed(false);

			    JScrollPane scrollPane = new JScrollPane(table);
			    panel.add(scrollPane, BorderLayout.CENTER);

			    getContentPane().add(panel);
			}
		} catch (Exception e) {
			throw new Exception(e.getMessage());
		}
	    
	}


	private static class CheckBoxRenderer extends DefaultTableCellRenderer {
	    private final JCheckBox checkBox;

	    public CheckBoxRenderer() {
	        checkBox = new JCheckBox();
	        checkBox.setHorizontalAlignment(JCheckBox.CENTER);
	    }

	    @Override
	    public Component getTableCellRendererComponent(JTable table, Object value,
	                                                   boolean isSelected, boolean hasFocus,
	                                                   int row, int column) {
	        if (value instanceof Boolean) {
	            checkBox.setSelected((Boolean) value);
	        }
	        
	        // øѡԱѡ
	        checkBox.setEnabled(true);
	        
	        return checkBox;
	    }
	}
	
	private class CheckBoxEditor extends DefaultCellEditor {
	    private JCheckBox checkBox;

	    public CheckBoxEditor() {
	        super(new JCheckBox());
	        checkBox = (JCheckBox) getComponent();
	        checkBox.setHorizontalAlignment(JCheckBox.CENTER);
	    }

	    @Override
	    public Object getCellEditorValue() {
	        return checkBox.isSelected();
	    }
	}
	
	class ActionHandler implements ActionListener {

		@Override
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == MultiSelectDialog.this.getBtnOK()) {
				// ȷťִ¼
				MultiSelectDialog.this.doOKAction();
			}
			
		}
	}
	
	private void doOKAction(){
		try {
			chend();
			List<Object[]> list  = getSelectedData();
			for (int i = 0; i < list.size(); i++) {
				//ѡеcode
				String code = list.get(i)[6].toString();
				for (int j = 0; j < listDefdocVO.size(); j++) {
					//ȡcode
					String codes = listDefdocVO.get(j).getCode();
					//ƥѡֵԶ嵵
					if(code.equals(codes)) {
						//˷Ʊϴƥ
						if(QryOCRNumber(code,null) == null) {
							DefdocVO defdocVO = listDefdocVO.get(j);
							idefservice.insertDefdocs(pk_group,new DefdocVO[] { defdocVO });
							
							break;
						}						
					}
				}
				
			}
			this.dispose();
		} catch (Exception e) {
			MessageDialog.showErrorDlg(null, NCLangRes.getInstance().getStrByID("pc", "FileManageUI-000000")/**/
					,e.getMessage());
		}
		
	}
	
	private void chend() throws Exception {
		//ƱδѡƱ
		List<Object[]> unlist = getUnselectedData();
		int count =editor.getBillCardPanel().getBodyPanel().getTable().getRowCount();//ϸ
		//ȡѾѡķƱ
		List<String> lisvdef20 = new ArrayList<String>();
		for(int i = 0;i<count;i++){
			Object objvbdef20 = editor.getBillCardPanel().getBodyValueAt(i, "vbdef20");//
			if(null != objvbdef20){
				String vbdef20 = objvbdef20.toString();
				String[] vbd20arry = vbdef20.split(",");
				for(int j = 0;j < vbd20arry.length;j++){
					lisvdef20.add(vbd20arry[j]);
				}
			}
		 }
		
		List<String> memoarry = QryDefMemo(lisvdef20);
		String number = "";
		for (int i = 0; i < unlist.size(); i++) {
			//Ʊûѡݣֱɾ
			if(memoarry.size() == 0) {
				number += unlist.get(i)[6] +",";
			}
			//δѡеķƱ
			String name = unlist.get(i)[8].toString();
			for (int j = 0; j < memoarry.size(); j++) {
				//ѡеķƱ
				String names = memoarry.get(j);
				if(name.equals(names)) {
					throw new Exception(name+":ƱѾѡȡѡ");
				}
				//Ʊѡݣƥûͬɾ
				if((j+1) == memoarry.size()) {
					number += unlist.get(i)[6] +",";
				}
			}
		}
		if(!"".equals(number)) {
			DeleteDOC(number);
		}
		
	}
	
	//ȡѡе
	private List<Object[]> getSelectedData() {
	    List<Object[]> selectedData = new ArrayList<Object[]>();

	    for (int i = 0; i < table.getRowCount(); i++) {
	        boolean isSelected = (Boolean) table.getValueAt(i, 0);
	        if (isSelected) {
	            Object[] rowData = new Object[table.getColumnCount()];
	            for (int j = 0; j < table.getColumnCount(); j++) {
	                rowData[j] = table.getValueAt(i, j);
	            }
	            selectedData.add(rowData);
	        }
	    }

	    return selectedData;
	}
	
	//ȡûѡе
	private List<Object[]> getUnselectedData() {
	    List<Object[]> unselectedData = new ArrayList<Object[]>();

	    for (int i = 0; i < table.getRowCount(); i++) {
	        boolean isSelected = (Boolean) table.getValueAt(i, 0);
	        if (!isSelected) { // ޸жΪ !isSelected
	            Object[] rowData = new Object[table.getColumnCount()];
	            for (int j = 0; j < table.getColumnCount(); j++) {
	                rowData[j] = table.getValueAt(i, j);
	            }
	            unselectedData.add(rowData);
	        }
	    }

	    return unselectedData;
	}

	
    //ѯԶ嵵pk
    private String QryOCRPk() throws Exception{
    	String sql = "select pk_defdoclist from bd_defdoclist where code='OCRTHNC' and nvl(dr,0)=0";
    	Object object = null;
			object = iuap.executeQuery(sql, new ColumnProcessor());
		if (object==null) {
			return null;
		}else {
			return object.toString();
		}
    }
	
    //ѯƱǷԶѴ
    private String QryOCRNumber(String number,String innercode) throws Exception{
    	StringBuffer sql = new StringBuffer();
    	sql.append("SELECT");
    	sql.append(" pk_defdoc ");
    	sql.append(" FROM");
    	sql.append(" bd_defdoc");
    	sql.append(" WHERE");
    	sql.append(" name6 = '"+vdef17+"'");
    	if(innercode != null) {
    		sql.append(" AND innercode = '"+innercode+"'");
    	}
    	sql.append(" AND code = '"+number+"'");
    	sql.append(" AND nvl( dr, 0 ) = 0");
		String pk_defdoc = (String) iuap.executeQuery(sql.toString(), new ColumnProcessor());
		return pk_defdoc;
    }
	
	
    //ҪķƱʱɾ
    private void DeleteDOC(String number) throws Exception {
    	String[] arrNumber = number.split(",");
    	SqlBuilder sql = new  SqlBuilder();
    	sql.append(" name6 = '"+vdef17+"'");
    	if(arrNumber.length == 1) {
    		sql.append(" AND code = '"+arrNumber.toString()+"'");
    	}else {
    		SqlBuilder sqlb = new SqlBuilder();
			sqlb.append("code", arrNumber);
    		sql.append(" AND  "+sqlb.toString());
    	}
    	
    	sql.append(" AND innercode = '1'");
    	sql.append(" AND pk_defdoclist = ( SELECT pk_defdoclist FROM bd_defdoclist WHERE code = 'OCRTHNC' AND nvl( dr, 0 ) = 0 )");
    	IVOPersistence.deleteByClause(DefdocVO.class, sql.toString());
    }
    
	private List<String> QryDefMemo(List<String> lisvdef20) throws Exception{
		 String[] arraydef20 = lisvdef20.toArray(new String[0]);
		 List<String> arrayvos = new ArrayList<String>();
		 if(null == arraydef20 || arraydef20.length == 0){
			 return arrayvos; 
		 }
		 
		 SqlBuilder	sqlb = new SqlBuilder();
		 sqlb.append("select memo  ");
		 sqlb.append("from  bd_defdoc ");
		 sqlb.append("where nvl(dr, 0) = 0 and pk_defdoclist= ");
		 sqlb.append("(select pk_defdoclist ");
		 sqlb.append("from bd_defdoclist ");
		 sqlb.append("where code='OCRTHNC' and nvl(dr,0)=0) ");
		 sqlb.append("and ");
		 sqlb.append("pk_defdoc", arraydef20);
		 ArrayList<String> objts = (ArrayList<String>) iuap.executeQuery(sqlb.toString(), new ColumnListProcessor("memo"));
		 if(null != objts && objts.size()>0){
			 arrayvos = objts;
		}
		
		 return arrayvos;
		
	}
}

